#ifndef _PARTICLE
#define _PARTICLE

#include "ofMain.h"
#include <fstream>
#include "ofxVectorMath.h"

class Particle {

    public:
        Particle ();
        Particle ( ofxVec2f pos );
        Particle ( ofxVec2f pos, ofxVec2f vel, float size, ofTexture* texture );
        ~Particle ();
        void setup ();

		void update ();
		void draw ();
		bool isOffscreen ();

		void setColor ( int r, int g, int b );
		void setColor ( ofColor c );

        ofxVec2f mPos;
        ofxVec2f mVel;

        float mSize;

        int mAge;
        int mLifetime;
        bool mDead;

        ofTexture* mTexture;

        int mColorR;
        int mColorG;
        int mColorB;
        int mOpacity;

};

#endif
