#ifndef _PARTICLE_CONTROLLER
#define _PARTICLE_CONTROLLER

#include "ofMain.h"
#include "particle.h"
#include "ofxVectorMath.h"

class ParticleController {

    public:
        ParticleController ();
        ParticleController ( ofTexture &ptext, ofxVec2f pos, int rate, float psizemin, float psizemax, float direction, float directiondev );
		void update ();
		void draw ();

		void addParticle ( ofxVec2f pos );
		void addParticles ( ofxVec2f pos, int amt );
		void addParticles ( int amt );
		void removeParticles ( int amt );

		int getParticleCount ();

        std::list<Particle> mParticles;

        int mRate; // emitting rate
        int mRateDeviation; // emitting rate deviation
        float mParticleSizeMin;
        float mParticleSizeMax;
        ofxVec2f mPosition; // position of the emitter
        float mDirection; // angle in degrees
        float mDirectionDeviation; // min/max deviation from Direction, angle in degrees
        ofTexture* mParticleTexture;

        int mColorIndex;
        int mDifferentColors;
        ofColor nextColor ();
};

#endif
